/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version: 1.3.21
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.osgeo.mapguide;



/**
 * {@link MgMeasure} is an abstract class that can be implemented to
 * provide non-linear measurement for geometry operations.
 *
 */
 public class MgMeasure extends MgGuardDisposable {
  private long swigCPtr;

  public MgMeasure(long cPtr, boolean cMemoryOwn) {
    super(MapGuideDesktopApiJNI.SWIGMgMeasureToMgGuardDisposable(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected MgMeasure() {
    this(0, false);
  }

  protected void finalize() {
    delete();
  }

  public void delete() {
    if(swigCPtr != 0 && swigCMemOwn) {
      swigCMemOwn = false;
      MapGuideDesktopApiJNI.delete_MgMeasure(swigCPtr);
    }
    swigCPtr = 0;
    super.delete();
  }

  protected static long getCPtr(MgMeasure obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  
/**
 * Gets the distance between two coordinates.
 *
 * @param  coord1  An {@link MgCoordinate} that specifies the first coordinate.
 * @param  coord2  An {@link MgCoordinate} that specifies the second coordinate.
 * @return  The distance between coord1 and coord2 as a double in Meters.
 */
 public double getDistance(MgCoordinate coord1, MgCoordinate coord2) {
    return MapGuideDesktopApiJNI.MgMeasure_GetDistance(swigCPtr, MgCoordinate.getCPtr(coord1), MgCoordinate.getCPtr(coord2));
  }

  
/**
 * Gets the angle with respect to the north of a vector formed by two
 * coordinates.
 *
 * @param  coord1  An {@link MgCoordinate} that specifies the first coordinate.
 * @param  coord2  An {@link MgCoordinate} that specifies the second coordinate.
 * @return  The azimuth (Angle with respect to the North) of the vector formed by
 *  coord1 and coord2.
 */
 public double getAzimuth(MgCoordinate coord1, MgCoordinate coord2) {
    return MapGuideDesktopApiJNI.MgMeasure_GetAzimuth(swigCPtr, MgCoordinate.getCPtr(coord1), MgCoordinate.getCPtr(coord2));
  }

  
/**
 * Computes a coordinate a given distance along a vector that is defined
 * by a starting coordinate and an azimuth (Angle with respect to the
 * North).
 *
 * @param  coord  An {@link MgCoordinate} that represents the start of the vector.
 * @param  azimuth  An azimuth (Angle with respect to the North) that defines the direction  of the vector.
 * @param  distance  The distance along the vector of the desired coordinate in Meters.
 * @return  An {@link MgCoordinate} that lies the given distance along the vector.
 */
 public MgCoordinate getCoordinate(MgCoordinate coord, double azimuth, double distance) {
    long cPtr = MapGuideDesktopApiJNI.MgMeasure_GetCoordinate(swigCPtr, MgCoordinate.getCPtr(coord), azimuth, distance);
    return (cPtr == 0) ? null : (MgCoordinate)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

}
